/******************************************************************************

                               Copyright (c) 2006 
                            Infineon Technologies AG 
                     Am Campeon 1-12; 81726 Munich, Germany 

  THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED NON-EXCLUSIVE, 
  WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE AND SUBLICENSE THIS 
  SOFTWARE IS FREE OF CHARGE. 

  THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY DISCLAIMS 
  ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR IMPLIED, INCLUDING 
  WITHOUT LIMITATION, WARRANTIES OR REPRESENTATIONS OF WORKMANSHIP, 
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, THAT THE 
  OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR FREE OR FREE OF ANY THIRD 
  PARTY CLAIMS, INCLUDING WITHOUT LIMITATION CLAIMS OF THIRD PARTY INTELLECTUAL 
  PROPERTY INFRINGEMENT. 

  EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND EXCEPT 
  FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE FOR ANY CLAIM 
  OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
  ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
  DEALINGS IN THE SOFTWARE. 

******************************************************************************/


#ifndef _DRV_DSL_CPE_VINAX_MSG_DEBUG_H
#define _DRV_DSL_CPE_VINAX_MSG_DEBUG_H

/** \file
   This chapter describes the messages which are used for debug purposes.
*/

#ifndef __PACKED__
   #if defined (__GNUC__) || defined (__GNUG__)
      /* GNU C or C++ compiler */
      #define __PACKED__ __attribute__ ((packed))
   #else
      /* Byte alignment adjustment */
      #pragma pack(1)
      #define __PACKED__      /* nothing */
   #endif
   #define __PACKED_DEFINED__ 1
#endif


/** @defgroup _DRV_DSL_CPE_VINAX_MSG_DEBUG_H Debug Messages
 *  @{
 */

#ifdef __cplusplus
   extern "C" {
#endif

/* ----- Include section ----- */
/* ----- Include section (End) ----- */

/* ----- Define section ----- */
/* ----- Define section (End) ----- */

/* ----- Constants Definition section ----- */
#define  CMD_DBG_TC_BlockSelect_xTC  0x00000000
#define  CMD_DBG_TC_BlockSelect_Alphaeus  0x00000001
#define  CMD_DBG_CounterBlockRead_COUNTER_MEM1  0x00000001
#define  CMD_DBG_CounterBlockRead_COUNTER_MEM2  0x00000002
#define  NFC_DBG_CounterBlockRead_COUNTER_MEM1  0x00000001
#define  NFC_DBG_CounterBlockRead_COUNTER_MEM2  0x00000002
#define  CMD_DBG_DebugVisMuxConfigure_TX_IFFT_OUT  0
#define  CMD_DBG_DebugVisMuxConfigure_VFDF_RX_TDQ_IN  1
#define  CMD_DBG_DebugVisMuxConfigure_VFDF_RX_TDQ_OUT  2
#define  CMD_DBG_DebugVisMuxConfigure_RX_FDQ_OUT  3
#define  CMD_DBG_DebugVisMuxConfigure_DSP_DATA  4
#define  CMD_DBG_DebugVisMuxConfigure_FDF_RX_TDQ_IN  5
#define  CMD_DBG_DebugVisMuxConfigure_FDF_RX_TDQ_OUT  6
#define  CMD_DBG_DebugVisMuxConfigure_NO_FLAG  0
#define  CMD_DBG_DebugVisMuxConfigure_DSP_FLAG  1
#define  CMD_DBG_DebugVisMuxConfigure_FT_TX_FRAME  2
#define  CMD_DBG_DebugVisMuxConfigure_FT_RX_FRAME  3
#define  CMD_DBG_DebugVisMuxConfigure_QT_TX_GO  4
#define  CMD_DBG_DebugVisMuxConfigure_DBGVIS_SEO  5
#define  CMD_DBG_DebugVisFormatSet_EVEN  0x0
#define  CMD_DBG_DebugVisFormatSet_ODD  0x1
#define  CMD_DBG_DebugVisFormatSet_ALL  0x0
#define  CMD_DBG_DebugVisFormatSet_EVEN_ODD  0x1
#define  CMD_DBG_DebugVisFormatSet_WORD  0x0
#define  CMD_DBG_DebugVisFormatSet_BYTE  0x1
#define  CMD_DBG_DebugVisDspStart_RX_FRAME_START  0
#define  CMD_DBG_DebugVisDspStart_RX_QT_DONE  1
#define  CMD_DBG_DebugVisDspStart_RX_FC_DONE  2
#define  CMD_DBG_DebugVisDspStart_TX_FRAME_START  3
#define  CMD_DBG_DebugVisDspStart_RX_TIMER_DONE  4
#define  CMD_DBG_DebugVisDspStart_TX_TIMER_DONE  5
#define  CMD_DBG_DebugVisDspStart_TX_IFFT_DONE  6
#define  CMD_DBG_DebugVisDspStart_RX_FFT_DONE  7
#define  CMD_DBG_DebugVisDspStart_TX_FC_DONE  8
#define  CMD_DBG_DebugVisDspStart_TX_QT_DONE  9
#define  CMD_DBG_DebugVisDspStart_TX_PARR_DONE  10
#define  CMD_DBG_xPTC_MessageTunnel_PP0  0
#define  CMD_DBG_xPTC_MessageTunnel_PP1  1
#define  ACK_DBG_xPTC_MessageTunnel_PP0  0
#define  ACK_DBG_xPTC_MessageTunnel_PP1  1
/* ----- Constants Definition section (End) ----- */

/** Message ID for CMD_DBG_MemMapRead */
#define CMD_DBG_MEMMAPREAD 0xA033

/**
   This command requests the content of the address contained as parameter.
*/
typedef struct CMD_DBG_MemMapRead CMD_DBG_MemMapRead_t;

/** Message ID for ACK_DBG_MemMapRead */
#define ACK_DBG_MEMMAPREAD 0xA033

/**
   Acknowledgement carrying the info requested by CMD_DBG_MemMapRead (result value of
   one read access).
*/
typedef struct ACK_DBG_MemMapRead ACK_DBG_MemMapRead_t;

/** Message ID for CMD_DBG_MemMapWrite */
#define CMD_DBG_MEMMAPWRITE 0xA173

/**
   The command writes a configurable value to a single arbitrary address.
*/
typedef struct CMD_DBG_MemMapWrite CMD_DBG_MemMapWrite_t;

/** Message ID for ACK_DBG_MemMapWrite */
#define ACK_DBG_MEMMAPWRITE 0xA173

/**
   Acknowledgement to a CMD_DBG_MemMapWrite command.
*/
typedef struct ACK_DBG_MemMapWrite ACK_DBG_MemMapWrite_t;

/** Message ID for CMD_DBG_AuxRegisterRead */
#define CMD_DBG_AUXREGISTERREAD 0xA233

/**
   This command requests the content an the auxiliary register with the address
   contained as parameter.
*/
typedef struct CMD_DBG_AuxRegisterRead CMD_DBG_AuxRegisterRead_t;

/** Message ID for ACK_DBG_AuxRegisterRead */
#define ACK_DBG_AUXREGISTERREAD 0xA233

/**
   The message acknowledges CMD_DBG_AuxRegisterRead and delivers the requested data.
*/
typedef struct ACK_DBG_AuxRegisterRead ACK_DBG_AuxRegisterRead_t;

/** Message ID for CMD_DBG_AuxRegisterWrite */
#define CMD_DBG_AUXREGISTERWRITE 0xA373

/**
   This message is sent from the host to write to any auxiliary register in the
   controller subsystem.
*/
typedef struct CMD_DBG_AuxRegisterWrite CMD_DBG_AuxRegisterWrite_t;

/** Message ID for ACK_DBG_AuxRegisterWrite */
#define ACK_DBG_AUXREGISTERWRITE 0xA373

/**
   Acknowledgement to a CMD_DBG_AuxRegisterWrite command.
*/
typedef struct ACK_DBG_AuxRegisterWrite ACK_DBG_AuxRegisterWrite_t;

/** Message ID for CMD_DBG_TC_BlockSelect */
#define CMD_DBG_TC_BLOCKSELECT 0x0473

/**
   This message is used to select the TC layer block. It is either Infineon xTC or
   Aware TC Alphaeus. This message has to be sent during the initialization phase
   before training. The default setting is Infineon xTC.
*/
typedef struct CMD_DBG_TC_BlockSelect CMD_DBG_TC_BlockSelect_t;

/** Message ID for ACK_DBG_TC_BlockSelect */
#define ACK_DBG_TC_BLOCKSELECT 0x0473

/**
   This message acknowledges the message CMD_DBG_TC_BlockSelect.
*/
typedef struct ACK_DBG_TC_BlockSelect ACK_DBG_TC_BlockSelect_t;

/** Message ID for CMD_DBG_TC_LayerLoopControl */
#define CMD_DBG_TC_LAYERLOOPCONTROL 0x0173

/**
   This message can be used to enable or disable the loop within the xTC block at the
   TC layer. It is applicable just if the Infineon TC block was selected. (see
   CMD_DBG_TC_BlockSelect)
*/
typedef struct CMD_DBG_TC_LayerLoopControl CMD_DBG_TC_LayerLoopControl_t;

/** Message ID for ACK_DBG_TC_LayerLoopControl */
#define ACK_DBG_TC_LAYERLOOPCONTROL 0x0173

/**
   This message acknowledges the message CMD_DBG_TC_LayerLoopControl.
*/
typedef struct ACK_DBG_TC_LayerLoopControl ACK_DBG_TC_LayerLoopControl_t;

/** Message ID for CMD_DBG_UTOPIA_WatchdogControl */
#define CMD_DBG_UTOPIA_WATCHDOGCONTROL 0xB273

/**
   Switches on/off an additional "keep-alive" supervision mechanism for the UTOPIA
   interface.
*/
typedef struct CMD_DBG_UTOPIA_WatchdogControl CMD_DBG_UTOPIA_WatchdogControl_t;

/** Message ID for ACK_DBG_UTOPIA_WatchdogControl */
#define ACK_DBG_UTOPIA_WATCHDOGCONTROL 0xB273

/**
   Acknowledgement to a CMD_DBG_UTOPIA_WatchdogControl command.
*/
typedef struct ACK_DBG_UTOPIA_WatchdogControl ACK_DBG_UTOPIA_WatchdogControl_t;

/** Message ID for CMD_DBG_WatchdogControl */
#define CMD_DBG_WATCHDOGCONTROL 0xB373

/**
   Switches on/off the HW watchdog by affecting timer T2 of the processor subsystem.
*/
typedef struct CMD_DBG_WatchdogControl CMD_DBG_WatchdogControl_t;

/** Message ID for ACK_DBG_WatchdogControl */
#define ACK_DBG_WATCHDOGCONTROL 0xB373

/**
   Acknowledgement to a CMD_DBG_WatchdogControl command.
*/
typedef struct ACK_DBG_WatchdogControl ACK_DBG_WatchdogControl_t;

/** Message ID for CMD_DBG_CounterBlockRead */
#define CMD_DBG_COUNTERBLOCKREAD 0x1033

/**
   The message requests a complete counter block from counter memory. The execution of
   the message is implemented in a non-time-critical task. The acknowledgement
   ACK_DBG_CounterBlockRead is a just formal immediate response without data. The
   requested data will be delivered afterwards with NFC_DBG_CounterBlockRead.
*/
typedef struct CMD_DBG_CounterBlockRead CMD_DBG_CounterBlockRead_t;

/** Message ID for ACK_DBG_CounterBlockRead */
#define ACK_DBG_COUNTERBLOCKREAD 0x1033

/**
   Acknowledgement to a CMD_DBG_CounterBlockRead command. This is a just formal
   acknowledgement without data. Data will be provided afterwards with
   NFC_DBG_CounterBlockRead.
*/
typedef struct ACK_DBG_CounterBlockRead ACK_DBG_CounterBlockRead_t;

/** Message ID for NFC_DBG_CounterBlockRead */
#define NFC_DBG_COUNTERBLOCKREAD 0x1033

/**
   This autonomous message delivers the data requested by CMD_DBG_CounterBlockRead.
*/
typedef struct NFC_DBG_CounterBlockRead NFC_DBG_CounterBlockRead_t;

/** Message ID for CMD_DBG_DebugVisMuxConfigure */
#define CMD_DBG_DEBUGVISMUXCONFIGURE 0x4073

/**
   Selects the data source for the Debug Visibility Port.
*/
typedef struct CMD_DBG_DebugVisMuxConfigure CMD_DBG_DebugVisMuxConfigure_t;

/** Message ID for ACK_DBG_DebugVisMuxConfigure */
#define ACK_DBG_DEBUGVISMUXCONFIGURE 0x4073

/**
   Acknowledgement to a CMD_DBG_DebugVisMuxConfigure command.
*/
typedef struct ACK_DBG_DebugVisMuxConfigure ACK_DBG_DebugVisMuxConfigure_t;

/** Message ID for CMD_DBG_DebugVisFormatSet */
#define CMD_DBG_DEBUGVISFORMATSET 0x4173

/**
   Configures the format of the output data on the Debug Visibility Port.
*/
typedef struct CMD_DBG_DebugVisFormatSet CMD_DBG_DebugVisFormatSet_t;

/** Message ID for ACK_DBG_DebugVisFormatSet */
#define ACK_DBG_DEBUGVISFORMATSET 0x4173

/**
   Acknowledgement to a CMD_DBG_DebugVisFormatSet command.
*/
typedef struct ACK_DBG_DebugVisFormatSet ACK_DBG_DebugVisFormatSet_t;

/** Message ID for CMD_DBG_DebugVisDummyValSet */
#define CMD_DBG_DEBUGVISDUMMYVALSET 0x4273

/**
   Controls the use of dummy value replacement on the Debug Visibility Port.
*/
typedef struct CMD_DBG_DebugVisDummyValSet CMD_DBG_DebugVisDummyValSet_t;

/** Message ID for ACK_DBG_DebugVisDummyValSet */
#define ACK_DBG_DEBUGVISDUMMYVALSET 0x4273

/**
   Acknowledgement to a CMD_DBG_DebugVisDummyValSet command.
*/
typedef struct ACK_DBG_DebugVisDummyValSet ACK_DBG_DebugVisDummyValSet_t;

/** Message ID for CMD_DBG_DebugVisCoreStart */
#define CMD_DBG_DEBUGVISCORESTART 0x4373

/**
   Starts the data acquisition from the selected hardware port. The data source of the
   Debug Visibility Port must not be configured as DSP_DATA, any other value is allowed
   (see CMD_DBG_DebugVisMuxConfigure, parameter DataSelect).
*/
typedef struct CMD_DBG_DebugVisCoreStart CMD_DBG_DebugVisCoreStart_t;

/** Message ID for ACK_DBG_DebugVisCoreStart */
#define ACK_DBG_DEBUGVISCORESTART 0x4373

/**
   Acknowledgement to a CMD_DBG_DebugVisCoreStart command.
*/
typedef struct ACK_DBG_DebugVisCoreStart ACK_DBG_DebugVisCoreStart_t;

/** Message ID for CMD_DBG_DebugVisDspStart */
#define CMD_DBG_DEBUGVISDSPSTART 0x4473

/**
   Starts the data acquisition of data written to the Debug Visibility Port by the DFE
   controller. The data source of the Debug Visibility Port must be configured as
   DSP_DATA. (see CMD_DBG_DebugVisMuxConfigure, parameter DataSelect).
*/
typedef struct CMD_DBG_DebugVisDspStart CMD_DBG_DebugVisDspStart_t;

/** Message ID for ACK_DBG_DebugVisDspStart */
#define ACK_DBG_DEBUGVISDSPSTART 0x4473

/**
   Acknowledgement to a CMD_DBG_DebugVisDspStart command.
*/
typedef struct ACK_DBG_DebugVisDspStart ACK_DBG_DebugVisDspStart_t;

/** Message ID for CMD_DBG_DebugVisStop */
#define CMD_DBG_DEBUGVISSTOP 0x4573

/**
   Stops the data acquisition on Debug Visibility Port.
*/
typedef struct CMD_DBG_DebugVisStop CMD_DBG_DebugVisStop_t;

/** Message ID for ACK_DBG_DebugVisStop */
#define ACK_DBG_DEBUGVISSTOP 0x4573

/**
   Acknowledgement to a CMD_DBG_DebugVisStop command.
*/
typedef struct ACK_DBG_DebugVisStop ACK_DBG_DebugVisStop_t;

/** Message ID for CMD_DBG_AFE_Read */
#define CMD_DBG_AFE_READ 0xA433

/**
   The command reads any AFE register.
*/
typedef struct CMD_DBG_AFE_Read CMD_DBG_AFE_Read_t;

/** Message ID for ACK_DBG_AFE_Read */
#define ACK_DBG_AFE_READ 0xA433

/**
   Acknowledge to a CMD_DBG_AFE_Read command. The acknowledge is just a formal one (to
   not block the host), and data are contained in a subsequent NFC_DBG_AFE_Read.
*/
typedef struct ACK_DBG_AFE_Read ACK_DBG_AFE_Read_t;

/** Message ID for NFC_DBG_AFE_Read */
#define NFC_DBG_AFE_READ 0xA433

/**
   Autonomous message delivering the content of the register requested by
   CMD_DBG_AFE_Read command.
*/
typedef struct NFC_DBG_AFE_Read NFC_DBG_AFE_Read_t;

/** Message ID for CMD_DBG_AFE_Write */
#define CMD_DBG_AFE_WRITE 0xA573

/**
   This messages writes a register inside the AFE.
*/
typedef struct CMD_DBG_AFE_Write CMD_DBG_AFE_Write_t;

/** Message ID for ACK_DBG_AFE_Write */
#define ACK_DBG_AFE_WRITE 0xA573

/**
   This acknowledge to CMD_DBG_AFE_Write is just a formal one (to not block the host),
   and success is confirmed with a subsequent NFC_DBG_AFE_Write.
*/
typedef struct ACK_DBG_AFE_Write ACK_DBG_AFE_Write_t;

/** Message ID for NFC_DBG_AFE_Write */
#define NFC_DBG_AFE_WRITE 0xA573

/**
   Autonomous message confirming a CMD_DBG_AFE_Write command after a formal
   ACK_DBG_AFE_Write.
*/
typedef struct NFC_DBG_AFE_Write NFC_DBG_AFE_Write_t;

/** Message ID for CMD_DBG_ErrorGenerationTimeRxSet */
#define CMD_DBG_ERRORGENERATIONTIMERXSET 0xB173

/**
   Generates errors of several error types in receive direction for a configurable
   period of time. The error generation can be enabled/disabled individually.
*/
typedef struct CMD_DBG_ErrorGenerationTimeRxSet CMD_DBG_ErrorGenerationTimeRxSet_t;

/** Message ID for ACK_DBG_ErrorGenerationTimeRxSet */
#define ACK_DBG_ERRORGENERATIONTIMERXSET 0xB173

/**
   Generates errors of several error types in receive direction for a configurable
   period of time. The error generation can be enabled/disabled individually.
*/
typedef struct ACK_DBG_ErrorGenerationTimeRxSet ACK_DBG_ErrorGenerationTimeRxSet_t;

/** Message ID for CMD_DBG_ARC_MailboxLoopback */
#define CMD_DBG_ARC_MAILBOXLOOPBACK 0xC073

/**
   This message requests the payload to be looped back with the Acknowledgment by the
   ARC mailbox.
*/
typedef struct CMD_DBG_ARC_MailboxLoopback CMD_DBG_ARC_MailboxLoopback_t;

/** Message ID for ACK_DBG_ARC_MailboxLoopback */
#define ACK_DBG_ARC_MAILBOXLOOPBACK 0xC073

/**
   Acknowledgement to CMD_DBG_ARC_MailboxLoopback looping back its payload.
*/
typedef struct ACK_DBG_ARC_MailboxLoopback ACK_DBG_ARC_MailboxLoopback_t;

/** Message ID for CMD_DBG_xPTC_MessageTunnel */
#define CMD_DBG_XPTC_MESSAGETUNNEL 0xC173

/**
   The message payload starting from Parameter 3 is simply forwarded from the ARC to
   the PP32 addressed with Parameter 2.
*/
typedef struct CMD_DBG_xPTC_MessageTunnel CMD_DBG_xPTC_MessageTunnel_t;

/** Message ID for ACK_DBG_xPTC_MessageTunnel */
#define ACK_DBG_XPTC_MESSAGETUNNEL 0xC173

/**
   Acknowledgement to CMD_DBG_xPTC_MessageTunnel.
*/
typedef struct ACK_DBG_xPTC_MessageTunnel ACK_DBG_xPTC_MessageTunnel_t;

/**
   This command requests the content of the address contained as parameter.
*/
struct CMD_DBG_MemMapRead
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#endif
} __PACKED__ ;


/**
   Acknowledgement carrying the info requested by CMD_DBG_MemMapRead (result value of
   one read access).
*/
struct ACK_DBG_MemMapRead
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** ReadValue */
   DSL_uint32_t ReadValue;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** ReadValue */
   DSL_uint32_t ReadValue;
#endif
} __PACKED__ ;


/**
   The command writes a configurable value to a single arbitrary address.
*/
struct CMD_DBG_MemMapWrite
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** WriteValue */
   DSL_uint32_t WriteValue;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** WriteValue */
   DSL_uint32_t WriteValue;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_MemMapWrite command.
*/
struct ACK_DBG_MemMapWrite
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#endif
} __PACKED__ ;


/**
   This command requests the content an the auxiliary register with the address
   contained as parameter.
*/
struct CMD_DBG_AuxRegisterRead
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Register Number */
   DSL_uint32_t RegNo;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Register Number */
   DSL_uint32_t RegNo;
#endif
} __PACKED__ ;


/**
   The message acknowledges CMD_DBG_AuxRegisterRead and delivers the requested data.
*/
struct ACK_DBG_AuxRegisterRead
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Register Number */
   DSL_uint32_t RegNo;
   /** Value */
   DSL_uint32_t Value;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Register Number */
   DSL_uint32_t RegNo;
   /** Value */
   DSL_uint32_t Value;
#endif
} __PACKED__ ;


/**
   This message is sent from the host to write to any auxiliary register in the
   controller subsystem.
*/
struct CMD_DBG_AuxRegisterWrite
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** Value */
   DSL_uint32_t Value;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** Value */
   DSL_uint32_t Value;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_AuxRegisterWrite command.
*/
struct ACK_DBG_AuxRegisterWrite
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#endif
} __PACKED__ ;


/**
   This message is used to select the TC layer block. It is either Infineon xTC or
   Aware TC Alphaeus. This message has to be sent during the initialization phase
   before training. The default setting is Infineon xTC.
*/
struct CMD_DBG_TC_BlockSelect
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** TC Block */
   DSL_uint32_t TC_Block;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** TC Block */
   DSL_uint32_t TC_Block;
#endif
} __PACKED__ ;


/**
   This message acknowledges the message CMD_DBG_TC_BlockSelect.
*/
struct ACK_DBG_TC_BlockSelect
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   This message can be used to enable or disable the loop within the xTC block at the
   TC layer. It is applicable just if the Infineon TC block was selected. (see
   CMD_DBG_TC_BlockSelect)
*/
struct CMD_DBG_TC_LayerLoopControl
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Link Number */
   DSL_uint32_t LinkNo;
   /** Control */
   DSL_uint32_t Control;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Link Number */
   DSL_uint32_t LinkNo;
   /** Control */
   DSL_uint32_t Control;
#endif
} __PACKED__ ;


/**
   This message acknowledges the message CMD_DBG_TC_LayerLoopControl.
*/
struct ACK_DBG_TC_LayerLoopControl
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Switches on/off an additional "keep-alive" supervision mechanism for the UTOPIA
   interface.
*/
struct CMD_DBG_UTOPIA_WatchdogControl
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** UTOPIA Watchdog Control */
   DSL_uint32_t Control;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** UTOPIA Watchdog Control */
   DSL_uint32_t Control;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_UTOPIA_WatchdogControl command.
*/
struct ACK_DBG_UTOPIA_WatchdogControl
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Switches on/off the HW watchdog by affecting timer T2 of the processor subsystem.
*/
struct CMD_DBG_WatchdogControl
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** HW Watchdog Control */
   DSL_uint32_t Control;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** HW Watchdog Control */
   DSL_uint32_t Control;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_WatchdogControl command.
*/
struct ACK_DBG_WatchdogControl
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   The message requests a complete counter block from counter memory. The execution of
   the message is implemented in a non-time-critical task. The acknowledgement
   ACK_DBG_CounterBlockRead is a just formal immediate response without data. The
   requested data will be delivered afterwards with NFC_DBG_CounterBlockRead.
*/
struct CMD_DBG_CounterBlockRead
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index (=Offset) */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** CntrBlock */
   DSL_uint32_t CntrBlock;
   /** Slice number */
   DSL_uint32_t Slice;
#else
   /** Index (=Offset) */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** CntrBlock */
   DSL_uint32_t CntrBlock;
   /** Slice number */
   DSL_uint32_t Slice;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_CounterBlockRead command. This is a just formal
   acknowledgement without data. Data will be provided afterwards with
   NFC_DBG_CounterBlockRead.
*/
struct ACK_DBG_CounterBlockRead
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index (=Offset) */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index (=Offset) */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   This autonomous message delivers the data requested by CMD_DBG_CounterBlockRead.
*/
struct NFC_DBG_CounterBlockRead
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index (=Offset) */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** CntrBlock */
   DSL_uint32_t CntrBlock;
   /** Slice number */
   DSL_uint32_t Slice;
   /** CounterValue */
   DSL_uint32_t CounterValue[62];
#else
   /** Index (=Offset) */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** CntrBlock */
   DSL_uint32_t CntrBlock;
   /** Slice number */
   DSL_uint32_t Slice;
   /** CounterValue */
   DSL_uint32_t CounterValue[62];
#endif
} __PACKED__ ;


/**
   Selects the data source for the Debug Visibility Port.
*/
struct CMD_DBG_DebugVisMuxConfigure
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** DataSelect */
   DSL_uint32_t DataSelect;
   /** FlagSelect */
   DSL_uint32_t FlagSelect;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** DataSelect */
   DSL_uint32_t DataSelect;
   /** FlagSelect */
   DSL_uint32_t FlagSelect;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_DebugVisMuxConfigure command.
*/
struct ACK_DBG_DebugVisMuxConfigure
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Configures the format of the output data on the Debug Visibility Port.
*/
struct CMD_DBG_DebugVisFormatSet
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Reserved */
   DSL_bf32_t Res00 : 28;
   /** EnableSelectToggle */
   DSL_bf32_t EnableSelToggle : 1;
   /** EvenOddSelect */
   DSL_bf32_t EvenOddSel : 1;
   /** EvenOddMode */
   DSL_bf32_t EvenOddMode : 1;
   /** DataWidth */
   DSL_bf32_t DataWidth : 1;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** DataWidth */
   DSL_bf32_t DataWidth : 1;
   /** EvenOddMode */
   DSL_bf32_t EvenOddMode : 1;
   /** EvenOddSelect */
   DSL_bf32_t EvenOddSel : 1;
   /** EnableSelectToggle */
   DSL_bf32_t EnableSelToggle : 1;
   /** Reserved */
   DSL_bf32_t Res00 : 28;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_DebugVisFormatSet command.
*/
struct ACK_DBG_DebugVisFormatSet
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Controls the use of dummy value replacement on the Debug Visibility Port.
*/
struct CMD_DBG_DebugVisDummyValSet
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Enable Dummy Value replacement */
   DSL_uint32_t EnableDummy;
   /** Dummy Value */
   DSL_uint32_t DummyValue;
   /** Replace Value */
   DSL_uint32_t ReplaceValue;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Enable Dummy Value replacement */
   DSL_uint32_t EnableDummy;
   /** Dummy Value */
   DSL_uint32_t DummyValue;
   /** Replace Value */
   DSL_uint32_t ReplaceValue;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_DebugVisDummyValSet command.
*/
struct ACK_DBG_DebugVisDummyValSet
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Starts the data acquisition from the selected hardware port. The data source of the
   Debug Visibility Port must not be configured as DSP_DATA, any other value is allowed
   (see CMD_DBG_DebugVisMuxConfigure, parameter DataSelect).
*/
struct CMD_DBG_DebugVisCoreStart
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Data Count */
   DSL_uint32_t DataCount;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Data Count */
   DSL_uint32_t DataCount;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_DebugVisCoreStart command.
*/
struct ACK_DBG_DebugVisCoreStart
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Starts the data acquisition of data written to the Debug Visibility Port by the DFE
   controller. The data source of the Debug Visibility Port must be configured as
   DSP_DATA. (see CMD_DBG_DebugVisMuxConfigure, parameter DataSelect).
*/
struct CMD_DBG_DebugVisDspStart
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Memory Location */
   DSL_uint32_t MemLoc;
   /** Trigger */
   DSL_uint32_t Trigger;
   /** Count */
   DSL_uint32_t Count;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Memory Location */
   DSL_uint32_t MemLoc;
   /** Trigger */
   DSL_uint32_t Trigger;
   /** Count */
   DSL_uint32_t Count;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_DebugVisDspStart command.
*/
struct ACK_DBG_DebugVisDspStart
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Stops the data acquisition on Debug Visibility Port.
*/
struct CMD_DBG_DebugVisStop
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Acknowledgement to a CMD_DBG_DebugVisStop command.
*/
struct ACK_DBG_DebugVisStop
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   The command reads any AFE register.
*/
struct CMD_DBG_AFE_Read
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#endif
} __PACKED__ ;


/**
   Acknowledge to a CMD_DBG_AFE_Read command. The acknowledge is just a formal one (to
   not block the host), and data are contained in a subsequent NFC_DBG_AFE_Read.
*/
struct ACK_DBG_AFE_Read
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Autonomous message delivering the content of the register requested by
   CMD_DBG_AFE_Read command.
*/
struct NFC_DBG_AFE_Read
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** ReadValue */
   DSL_uint32_t ReadValue;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** ReadValue */
   DSL_uint32_t ReadValue;
#endif
} __PACKED__ ;


/**
   This messages writes a register inside the AFE.
*/
struct CMD_DBG_AFE_Write
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** WriteValue */
   DSL_uint32_t WriteValue;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
   /** WriteValue */
   DSL_uint32_t WriteValue;
#endif
} __PACKED__ ;


/**
   This acknowledge to CMD_DBG_AFE_Write is just a formal one (to not block the host),
   and success is confirmed with a subsequent NFC_DBG_AFE_Write.
*/
struct ACK_DBG_AFE_Write
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   Autonomous message confirming a CMD_DBG_AFE_Write command after a formal
   ACK_DBG_AFE_Write.
*/
struct NFC_DBG_AFE_Write
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Address */
   DSL_uint32_t Address;
#endif
} __PACKED__ ;


/**
   Generates errors of several error types in receive direction for a configurable
   period of time. The error generation can be enabled/disabled individually.
*/
struct CMD_DBG_ErrorGenerationTimeRxSet
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Reserved */
   DSL_bf32_t Res00 : 30;
   /** Enable Bit1 */
   DSL_bf32_t E1 : 1;
   /** Enable Bit0 */
   DSL_bf32_t E0 : 1;
   /** OOS Error Period for PTM, BC0 */
   DSL_uint32_t OOS_TimeBC0;
   /** OOS Error Period for PTM, BC1 */
   DSL_uint32_t OOS_TimeBC1;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Enable Bit0 */
   DSL_bf32_t E0 : 1;
   /** Enable Bit1 */
   DSL_bf32_t E1 : 1;
   /** Reserved */
   DSL_bf32_t Res00 : 30;
   /** OOS Error Period for PTM, BC0 */
   DSL_uint32_t OOS_TimeBC0;
   /** OOS Error Period for PTM, BC1 */
   DSL_uint32_t OOS_TimeBC1;
#endif
} __PACKED__ ;


/**
   Generates errors of several error types in receive direction for a configurable
   period of time. The error generation can be enabled/disabled individually.
*/
struct ACK_DBG_ErrorGenerationTimeRxSet
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
#endif
} __PACKED__ ;


/**
   This message requests the payload to be looped back with the Acknowledgment by the
   ARC mailbox.
*/
struct CMD_DBG_ARC_MailboxLoopback
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Data */
   DSL_uint32_t data[64];
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Data */
   DSL_uint32_t data[64];
#endif
} __PACKED__ ;


/**
   Acknowledgement to CMD_DBG_ARC_MailboxLoopback looping back its payload.
*/
struct ACK_DBG_ARC_MailboxLoopback
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Data */
   DSL_uint32_t data[64];
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** Data */
   DSL_uint32_t data[64];
#endif
} __PACKED__ ;


/**
   The message payload starting from Parameter 3 is simply forwarded from the ARC to
   the PP32 addressed with Parameter 2.
*/
struct CMD_DBG_xPTC_MessageTunnel
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** PP32 selection */
   DSL_uint32_t PP_select;
   /** xPTC Message */
   DSL_uint32_t PP_msgIn[63];
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** PP32 selection */
   DSL_uint32_t PP_select;
   /** xPTC Message */
   DSL_uint32_t PP_msgIn[63];
#endif
} __PACKED__ ;


/**
   Acknowledgement to CMD_DBG_xPTC_MessageTunnel.
*/
struct ACK_DBG_xPTC_MessageTunnel
{
#if DSL_BYTE_ORDER == DSL_BIG_ENDIAN
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** PP32 selection */
   DSL_uint32_t PP_select;
   /** xPTC Message */
   DSL_uint32_t PP_msgOut[63];
#else
   /** Index */
   DSL_uint16_t Index;
   /** Length */
   DSL_uint16_t Length;
   /** PP32 selection */
   DSL_uint32_t PP_select;
   /** xPTC Message */
   DSL_uint32_t PP_msgOut[63];
#endif
} __PACKED__ ;


#ifdef __cplusplus
}
#endif

#ifdef __PACKED_DEFINED__
   #if !(defined (__GNUC__) || defined (__GNUG__))
      #pragma pack()
   #endif
   #undef __PACKED_DEFINED__
#endif /* __PACKED_DEFINED__ */

/** @} */
#endif
